/*
*
* versuch project
* Address Utilities
* $Id: AddrUtils.h,v 1.1 2006/03/06 13:07:56 warlock_kg Exp $
* warlock copyright since 2005 Nov
*
*/


#ifndef _ADDR_UTILS_H
#define _ADDR_UTILS_H

#include <h225.h>

#include <stdexcept>
#include <vector>
#include <string>

#include "Sockets.h"

using namespace std;

namespace AddrUtils
{
 void setIPAddress(H245_UnicastAddress_iPAddress & IP, const WSocket::Address & addr, unsigned port) ;
 // Given an array of transport address, returns the first IP address
 //       will throw an error if no IP address
 void GetIPAddress(H225_TransportAddress_ipAddress &  IPAddr,
               const H225_ArrayOf_TransportAddress &    Addresses );
 // Task: given an array of transport address, returns the first IP address
 //       will throw an error if no IP address
 void GetIPAddress( H225_TransportAddress &            IPAddr,
      const H225_ArrayOf_TransportAddress &    Addresses );
 class IPAddrNotFoundError : public runtime_error
 {
   public:
     IPAddrNotFoundError(const string& what_arg): runtime_error(what_arg) {}
 };
 H225_TransportAddress ConvertToH225TransportAddr( const WSocket::Address & Addr, unsigned Port );
 void ConvertToIPAddress( const H225_TransportAddress_ipAddress &   H225IP, WSocket::Address & Addr, unsigned & Port );

// Convert stream into PString
 PString AsString(const PASN_OctetString & Octets);
// Perl RegExps
 string PerlTranslate(const string RegExp, const string & Subject);
// General translation for every incoming calls
 void IncomingTranslate(PString & CalledNum, const vector<string> & CalledPattern);
 void MapToSocketList(vector< WSocket * > & SocketList, map<unsigned, WTCPSocket *> & Source);
}

#endif // _ADDR_UTILS_H
