/*
*
* versuch project
* global objects
* $Id: global.h,v 1.9 2006/08/24 06:44:48 warlock_kg Exp $
* warlock copyright since 2005 Nov
*
*/

#ifndef _GLOBAL_H__
#define _GLOBAL_H__

#include "Sockets.h"
#include "Utils.h"

#include <h225.h>
#include <vector>
#include <map>

class TPortRange
{
protected:
 int GetFree(bool IsTCP);
public:
 TPortRange(const PString sRange);
 virtual ~TPortRange() {};
 int MinPort, MaxPort, LastPort;
};

class TUDPPortRange : public TPortRange
{
public:
 TUDPPortRange(const PString sRange);
 int GetFreePort();
};

class TTCPPortRange : public TPortRange
{
public:
 TTCPPortRange(const PString sRange);
 int GetFreePort();
};

class TGateways;
class TDialPeers;

class TGlobal
{
public:
 TGlobal();
 ~TGlobal();
 bool OpenCfg(const PFilePath & fp);
 TConfig* 		cfg;
 WSocket::Address	ListenAddr, OutAddr, DebugSourceHost;
 TUDPPortRange*		RTPPortRange;
 TTCPPortRange*		H245PortRange;
 string			ID, GatewaysConf;
 bool			BlockG711, RadStopOnly;
 unsigned		StatusPort, LogRotateSpan;
 vector<string>		IncTlCalled, BlockRoutingCauses;
 unsigned 		MinDigitsDefault; // Minimal digits in CalledNumber
 string			AcctType, AuthType, LogFile, AcctVSAPrefix, AuthVSAPrefix, LogUmask;
 string			AcctRadHost, AcctRadSecret, AuthRadHost, AuthRadSecret, PeerFile;
 int 			AcctRadPort, AuthRadPort, AcctRadMode;
 pthread_mutex_t 	global_mtx;
 TGateways * 		Gateways;
 TDialPeers *		DialPeers;
 PArgList 		args;
 PFilePath 		fp;
 bool ReadMap(const string FileName, map<string, string> & mMap);
 bool IsBlockingCause(int Code);
 bool ReadFile();
};

class TMessLog
{
private:
 vector<string> mLog;
public:
 TMessLog()  { };
 void Add(const char * Level, const char * Text, bool Sender);
 string Output();
};

class TGateDescr
{
public:
 TGateDescr() { Capacity = 0 ; } ;
 string Address, DeferMsg;
 int Capacity;
};

class TGateways
{
public:
 TGateways() {};
 ~TGateways();
 void ReadFile(const string FileName);
 map<string, TGateDescr*> gwList;
private:
 void EraseData();
 bool AddPair(const string GW, string & Key, const string Field);
};

class TVoicePeer
{
public:
 TVoicePeer();
 string Key;
 string DestPattern, SrcPattern;
 string TargetGW, dst_translate, dst_bill_translate, src_translate, src_bill_translate;
 unsigned int Preference, HuntStop, Proxy;
};

class TDialPeers
{
public:
 TDialPeers() {};
 ~TDialPeers();
 bool ReadFile(const string FileName);
 map<string, TVoicePeer*> List;
private:
  void EraseData();
  bool AddPair(const string GW, string & Key, const string Field);
};

#endif
