/*
*
* versuch project
* H245 handler & thread
* $Id: h245.h,v 1.1 2006/03/06 13:07:56 warlock_kg Exp $
* warlock copyright since 2005 Nov
*
*/

#ifndef _H245_H
#define _H245_H

#include <pthread.h>

#include "Sockets.h"
#include "CallThread.h"

class CallThread;
class SignallingThread;
class TCallPool;

class H245Handler
{
 public:
   H245Handler(SignallingThread * SigThread);
   virtual ~H245Handler();
   virtual void HandleMesg( H245_MultimediaSystemControlMessage & Mesg, unsigned CallRef, bool FromCaller);
   virtual void HandleOpenLogicalChannel( H245_OpenLogicalChannel & olc, unsigned CallRef, bool FromCaller);
   virtual void HandleOpenLogicalChannelAck( H245_OpenLogicalChannelAck & msg , unsigned CallRef, bool FromCaller );
 protected:
   virtual void HandleRequest( H245_RequestMessage & Request, unsigned Callref, bool FromCaller );
   virtual void HandleResponse( H245_ResponseMessage & Response, unsigned CallRef, bool FromCaller );
   virtual void HandleCommand( H245_CommandMessage & Command, unsigned CallRef, bool FromCaller );
   virtual void HandleIndication( H245_IndicationMessage & Indication, unsigned CallRef, bool FromCaller );
   virtual void HandleTCSRequest(H245_RequestMessage & Request, bool BlockG711);
   SignallingThread * SigThread;
};

class H245Thread;

struct T_h245_thread_data
{
 H245Thread * ch;
};

class H245Thread : public H245Handler
{
 public:
  H245Thread( TGlobal & AkaEnviron, TCallPool * vCallPool, unsigned CallRef, const H225_TransportAddress & TransportAddress, bool FromCaller );
  virtual ~H245Thread();
  void SetTransportAddress(const H225_TransportAddress & TransportAddress, bool FromCaller);
  bool GetListenerAddress(bool IsInListener, H225_TransportAddress & TransAddr);
  bool GetListenerAddress(bool IsInListener, WSocket::Address & Addr, unsigned & Port);
  void Close();
  void WaitForTermination();
  pthread_t GetThreadName() {return ThreadID; };
  virtual void Main();
  void AllocateSecondListener(bool IsInListener);
  void UnregCallPool();
  void SetStop() {Stop = true;};
  struct T_h245_thread_data * h245_tdata;
 private:
  void ReceiveMesg( WTCPSocket * From, WTCPSocket * To, bool FromCaller);
  void ProcessMesg( H245_MultimediaSystemControlMessage &  Mesg, WTCPSocket *  Target, bool FromCaller );
  void HandleCommand( H245_CommandMessage & Command, unsigned CallRef, bool FromCaller );
  bool Connecting();
  bool MakeConnection(bool IsInListener);
  TGlobal &    env;
  WTCPSocket   * inSocket, * outSocket;
  WTCPSocket   inListener, outListener;
  bool         SessionEnded, InitCaller;
  TCallPool *  CallPool;
  unsigned     CallRef;
  pthread_t    ThreadID;
  H225_TransportAddress_ipAddress inTransportAddress, outTransportAddress;
  bool Running, Stop;
  int pipes[2];
};

bool StartH245Thread(pthread_t & ThreadID, TGlobal & AkaEnviron, TCallPool * vCallPool, unsigned CallRef, 
		const H225_TransportAddress & Address, bool FromCaller);

#endif // _H245_H
