/*
* 
* versuch project
* H323 proxy
* $Id: versuch.cxx,v 1.5 2006/08/11 12:44:29 warlock_kg Exp $
* warlock copyright since 2005 Nov
*
*/

#include <ptlib.h>
#include <assert.h>

#include "global.h"
#include "CallThread.h"

 PTextFile *logfile = 0;
 PString logfilename;

void ReopenLogFile()
{
 if (!logfilename) {
   WTrace::SetStream(&cerr); // redirect to cerr
   delete logfile;
   logfile = new PTextFile(logfilename, PFile::WriteOnly, PFile::Create);
   if (!logfile->IsOpen()) {
       cerr << "Warning: could not open trace output file \""
       << logfilename << '"' << endl;
        delete logfile;
        logfile = 0;
        return;
    }
    logfile->SetPosition(logfile->GetLength());
    WTrace::SetStream(logfile); // redirect to logfile
  }
  WTRACE(1, "GK\tTrace logging restarted.");
}

class versuch
{
 public:
  void Main(int argc, char *argv[]);
  void PrintHelp(); 
  bool InitConfig(const PArgList &args, TGlobal & env);
 private:
  const PString GetArgumentsParseString(); 
};

void * call_thread_function( void *ptr )
{
 struct T_call_thread_data * thread_data;
 WTRACE(1, "tEntering to call_thread_function. ptr= " << ptr);
 thread_data = (struct T_call_thread_data *) ptr;
 thread_data -> ch -> Main();
 WTRACE(1, "Exiting from call_thread_function");
 pthread_exit(0);
}

void versuch::Main(int argc, char *argv[])
{
  TGlobal env;
  // PArgList args;
  env.args.SetArgs(argc-1, argv+1 );
  env.args.Parse(GetArgumentsParseString());

  if (env.args.HasOption('h')) {
    PrintHelp();
    exit(0);
  }
  if ( !InitConfig(env.args, env) ) {
    cerr << "Read config fails" << endl;
    exit(0);
  }

  pthread_t cThreadID;
  CallThread * CThread = new CallThread( env );
  CThread -> call_tdata -> ch = CThread;
  WTRACE(1, "Starting CallThread");
  if ( pthread_create( &cThreadID,  NULL, call_thread_function, (void *) CThread -> call_tdata  ) != 0 ) {
    WTRACE(1,"pthread_create fails for CallThread. errno = " << errno );
    assert (false);
  }
  if ( (pthread_detach(cThreadID)) != 0) 
        WTRACE(1, "Call pthread_detach error" << cThreadID);
  WTRACE(1, "CallThread started");

 // Clean up
  CThread->WaitForTermination();
  CThread->Close();

  delete CThread;
}

void versuch::PrintHelp()
{
 cout << "Usage: " << endl <<
	"  -t  --trace		: Set trace verbosity" << endl <<
	"  -o  --output file	: Write trace to this file" << endl <<
	"  -c  --config file	: Specify which config file to use" << endl <<
	"  -h  --help		: Help message" << endl ;
}

const PString versuch::GetArgumentsParseString()
{
 return PString
	("t-trace." "o-output:"
	"h-help:" "c-config:" );
}

bool versuch::InitConfig(const PArgList &args, TGlobal  & env)
{
// WTRACE initialize
 string str0;
#if PTRACING
  WTrace::Initialise( );
  WTrace::SetOptions(WTrace::DateAndTime | WTrace::TraceLevel | WTrace::ThreadAddress);
//  WTrace::SetOptions(WTrace::DateAndTime | WTrace::TraceLevel);
#endif
  WTrace::SetLevel(args.GetOptionCount('t'));
  if (args.HasOption('o')) {
    logfilename = args.GetOptionString('o');
    ReopenLogFile();
  }
 WTRACE(1, "Config init");
// get the config file
 PFilePath fp("versuch.ini");
 
 if (args.HasOption('c'))
    fp = PFilePath(args.GetOptionString('c'));
 env.fp = fp;
 return (env.ReadFile());
}

int main (int argc, char *argv[])
{
 versuch Proccess;
 Proccess.Main(argc, argv);
}
